#include "ks0108.h"

volatile unsigned int i=0;




void Status_read(void) //DONE
{
	DDR_DATA_PORT = 0x00;
	CMD_PORT |= (1<<RW);
	CMD_PORT &= ~(1<<DI);
	CMD_PORT |= (1<<EN);
	
	while(DATA_PORT_2 == BUSY)

	CMD_PORT &= ~((1<<RW) | (1<<DI) | (1<<EN));
	DDR_DATA_PORT = 0xFF;
	CMD_PORT |= (1<<DI);
}



void Screen_clr(void) //DONE
{
	unsigned char j;
	unsigned char k;
	unsigned char i;
	for(j = 0; j<2;j++)
	{
		Write_cmd(DISP_OFF, j);
		GotoXY(0,0);

		for(k = 0;k<8;k++)
		{
			Write_cmd((SET_PAGE | k), j);
			for(i = 0;i<64;i++)
			{
				Write_data(0x00);
			}
		}
		Write_cmd(DISP_ON, j);
		Write_cmd(SET_PAGE, j);
	}
}



void Select_chip(unsigned char CHIP) //DONE
{

	if(CHIP == CS2)
	{
		CMD_PORT |= (1<<CSS1);
		CMD_PORT &= ~(1<<CSS2);
	}

	if(CHIP == CS1)
	{
		CMD_PORT |= (1<<CSS2);
		CMD_PORT &= ~(1<<CSS1);
	}
}



void Write_data(unsigned char Data) //DONE
{
	CMD_PORT |= (1<<DI);
	CMD_PORT &= ~(1<<RW);

	DATA_PORT = Data;

	Enable();
	DATA_PORT = 0x00;

}



void Enable(void) //DONE
{
	CMD_PORT |= (1<<EN);
	for(i=0;i<2;i++);
	CMD_PORT &= ~(1<<EN);
	for(i=0;i<2;i++);
}



void GotoXY(unsigned char x, unsigned char y) //DONE
{

	if(x>127)
		x = 0;
	if(y>63)
		y = 0;

	if(x>63)
	{
		x = x -64;
		//Select_chip(CS2);
		Write_cmd((SET_PAGE | (y/8)), CS2);
		Write_cmd((SET_ADD | x), CS2);
	}

	else 
	{
		//Select_chip(CS1);
		Write_cmd((SET_PAGE | (y/8)), CS1);
		Write_cmd((SET_ADD | x), CS1);
	}
}





void Write_cmd(unsigned char cmd, unsigned char CHIP) //DONE
{
	CMD_PORT &= ~((1<<DI) | (1<<RW) | (1<<EN));
	Select_chip(CHIP);
	
	DDR_DATA_PORT = 0xFF;

	DATA_PORT = cmd;
	Enable();
	//DATA_PORT = 0x00;
}




void Init_LCD(void) //DONE
{
	DDR_CMD_PORT |= 0xF8;
	Write_cmd(DISP_ON, CS1);
	Write_cmd(DISP_ON, CS2);

	Write_cmd(START_LINE, CS1);
	Write_cmd(START_LINE, CS2);

	Write_cmd(SET_ADD, CS1);
	Write_cmd(SET_ADD, CS2);
	Screen_clr();
}



void put_char(unsigned char print_char, unsigned char xpos, unsigned char ypos,unsigned char *font)
{
	unsigned char a=0;
	unsigned char b=0;
	unsigned char x = 0;
	unsigned char max;
	unsigned char maxcnt=0;
	unsigned char page;
	unsigned char breite_cnt;
	unsigned char CHIP;
	unsigned char breite;
	unsigned char hoehe;
	
	breite = pgm_read_byte(font);
	hoehe = pgm_read_byte(font+1);

	page = ypos/8;
	a = ypos - ((ypos/8)*8);
	
	max = hoehe/8;
	
	
	if(ypos-((ypos/8)*8) != 0)
	{
		max++;
		b = 8 - a;
		
	}
	


	if(xpos>63)
		CHIP=CS2;
	else
		CHIP=CS1;
	Write_cmd(SET_PAGE | page, CHIP);
	Write_cmd(SET_ADD | xpos, CHIP);
	for(breite_cnt=0;breite_cnt<breite;breite_cnt++)
	{

		if(CHIP == CS1 && (xpos + breite_cnt)>63)
		{
			CHIP = CS2;
			Write_cmd(SET_PAGE | page, CHIP);
			Write_cmd(SET_ADD | 0, CHIP);
		}
		Write_data(pgm_read_byte(font+3 + (hoehe/8)*(breite_cnt + breite*(print_char - pgm_read_byte(font + 2))))<<a);
	}

	if(xpos>63)
		CHIP=CS2;
	else
		CHIP=CS1;
	page++;

	Write_cmd(SET_PAGE | page, CHIP);
	Write_cmd(SET_ADD | xpos, CHIP);
	while(((maxcnt + 1) < (max - x)) && (max>2))
	{
		if(ypos-((ypos/8)*8) != 0)
			x = 1;
		maxcnt++;
		for(breite_cnt=0;breite_cnt<breite;breite_cnt++)
		{
			if(CHIP == CS1 && (xpos + breite_cnt)>63)
			{
				CHIP = CS2;
				Write_cmd(SET_PAGE | page, CHIP);
				Write_cmd(SET_ADD | 0, CHIP);
			}
			Write_data((pgm_read_byte(font + 3 + maxcnt - 1 + (hoehe/8)*(breite_cnt + breite*(print_char - pgm_read_byte(font + 2))))>>b) | (pgm_read_byte(font + 3 + maxcnt + (hoehe/8)*(breite_cnt + breite*(print_char - pgm_read_byte(font + 2))))<<a));
			//UDR = 2;
			//_delay_ms(10);
		}
		if(xpos>63)
			CHIP=CS2;
		else
			CHIP=CS1;
		page++;
		Write_cmd(SET_PAGE | page, CHIP);
		Write_cmd(SET_ADD | xpos, CHIP);
	}

	if(max>1)
	{
		maxcnt++;
		if(ypos - ((ypos/8)*8) != 0)
			maxcnt--;
		for(breite_cnt=0;breite_cnt<breite;breite_cnt++)
		{
			
			if(CHIP == CS1 && (xpos + breite_cnt)>63)
			{
				CHIP = CS2;
				Write_cmd(SET_PAGE | page, CHIP);
				Write_cmd(SET_ADD | 0, CHIP);
			}
			Write_data(pgm_read_byte(font + 3 + maxcnt + (hoehe/8)*(breite_cnt + breite*(print_char - pgm_read_byte(font + 2))))>>b);
			//UDR = 3;
			//_delay_ms(10);
		}
	}	
}



void put_number(float zahl, unsigned char x, unsigned char y, unsigned char laenge, unsigned char prec, unsigned char *font)
{	
	
	char str_zahl[laenge];
	unsigned char cnt;
	dtostrf(zahl,laenge,prec, str_zahl);

	for(cnt=0;cnt<laenge;cnt++)
	{
		if(str_zahl[cnt] == 32)
			put_char('0',x,y,font);
		else
			put_char(str_zahl[cnt],x,y,font);
		x = x + pgm_read_byte(font);
	}

}


void put_string(unsigned char *show_string, unsigned char x, unsigned char y, unsigned char *font)
{	

	unsigned char cnt;
	for(cnt=0;cnt<strlen(show_string);cnt++)
	{

		put_char(show_string[cnt],x,y,font);
		x = x + pgm_read_byte(font);
	}
}




