#ifndef ks0108_h
#define ks0108_h

#include "includes.h"


//CMD-Port
#define DDR_CMD_PORT		DDRC
#define CMD_PORT 			PORTC

#define CS1 				0x00
#define CS2 				0x01


#define CSS1 				0x07
#define CSS2 				0x06
#define RW 					0x05
#define DI					0x04
#define EN 					0x03



//DATA-Port
#define DDR_DATA_PORT		DDRB
#define DATA_PORT 			PORTB
#define DATA_PORT_2			PINB

//LCD_Kommandos
#define DISP_ON				0x3F
#define DISP_OFF			0x3E
#define SET_ADD				0x40
#define SET_PAGE			0xB8
#define START_LINE			0xC0


//LCD_Status
#define BUSY				0x80
#define	ON_OFF				0x20
#define RESET 				0x10





//Funktionen
void Status_read(void);
void Screen_clr(void);
void Select_chip(unsigned char CHIP);
void Write_data(unsigned char Data);
void Enable(void);
void GotoXY(unsigned char x, unsigned char y);
void Write_cmd(unsigned char cmd, unsigned char CHIP);
void Init_LCD(void);
void put_char(unsigned char, unsigned char, unsigned char, unsigned char *);
void put_number(float, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char *);
void put_string(unsigned char *, unsigned char, unsigned char, unsigned char *);



#endif
